<?php

declare(strict_types=1);

namespace Fbrinker\ExtensionCheck\Command;

use Fbrinker\ExtensionCheck\Extension\ExtensionCheck;
use Fbrinker\ExtensionCheck\Extension\ExtensionDetails;
use Fbrinker\ExtensionCheck\Output\SymfonyStyleFactory;
use Fbrinker\ExtensionCheck\Parser\FileParser;
use Interop\Container\ContainerInterface;
use Laminas\ServiceManager\Factory\FactoryInterface;

class CheckCommandFactory implements FactoryInterface
{
    /**
     * @param array<mixed> $options
     */
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null)
    {
        return new CheckCommand(
            $container->get(SymfonyStyleFactory::class),
            $container->get(FileParser::class),
            $container->get(ExtensionCheck::class)
        );
    }
}
